<?
require "lib/setup.php";
require PRISCILLA_LOCAL_PATH."adm/lib/test_auth.php";

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

$usertable = $PRISCILLA_SESSION->getvalue('usertable');
$skin = $PRISCILLA_SESSION->getvalue('sk');
$lang = $PRISCILLA_SESSION->getvalue('lingua');

if ($_GET['relationTable'])
    $relationTable = $_GET['relationTable'];
elseif ($_POST['relationTable'])
    $relationTable = $_POST['relationTable'];

if ($relationTable == 'community_userFields')
    $relationField = 'id_community';
    //$relationId = $_GET['id_community'] ? $_GET['id_community'] : $_POST['id_community'];
elseif ($relationTable == 'catalogo_fields')
    $relationField = 'id_catalogo';

require_once PRISCILLA_LOCAL_PATH."tools/lang/$lang/adm_dialog.diz";
require_once PRISCILLA_LOCAL_PATH."tools/lang/$lang/error.diz";

// require della lib swaplang per operazioni su tabelle-contenuti di lingua
$langlabels = array();
$langs = array();
if (file_exists(PRISCILLA_LOCAL_PATH."modules/swaplang/lib/swaplang.lib.php")) {
    require_once PRISCILLA_LOCAL_PATH."modules/swaplang/lib/swaplang.lib.php";
    getLanguagesStruct($langlabels, $langs);
}

// corrispondeza tipi -> lingua
$F_TYPES = array('varchar' => 'testo', 'text' => 'testo lungo', 'int' => 'numero', 'date' => 'data');

if ($relationTable != '')
{
    $relationTableAttrib = array();
    $totRelationAttrib = 0;
    $where = '';
    if ($relationField && $relationId)
        $where = "WHERE `".$relationField."`='".$relationId."'";
    $query = "SELECT * FROM $relationTable $where";
    $rsRel = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());
    if ($rsRel->RecordCount() > 0)
        $relArray = $connh->getAll($query);
    for ($i = 0; $i < $rsRel->FieldCount(); $i++)
    {
        $field = $rsRel->FetchField($i);
        if ($field->name != 'id' and $field->name != 'nome' and $field->name != 'id_community'  and $field->name != 'id_catalogo')
        {
            $relationTableAttrib[] = $field->name;
            $totRelationAttrib++;
        }
        elseif ($field->name == 'nome')
            $relationTableFieldsName[$field->name] = $rsRel->fields[$field->name];
    }
}

if ($action == 'add')
{
    if ($tipo == 'text' or $tipo == 'int' or $tipo == 'date') $lung_str = '';
    else $lung_str = "($lunghezza)";
    $nome = trim($nome);
    $nome = str_replace(' ', '_', $nome);
    $query = "ALTER TABLE $table ADD $nome $tipo $lung_str";
    $rs = $connh->Execute($query);

    // eseguo l'operazione anche per le corrispettive tabelle di lingua
    if (count($langs[$table]))
    foreach ($langs[$table] as $langtable => $langlabel) {
        $query = "ALTER TABLE $langtable ADD $nome $tipo $lung_str";
        $rs = $connh->Execute($query);
    }

    if ($relationTable) {
        /*if ($relationTable == 'community_userFields' && is_array($_POST['id_relations'])) {
            $idcoms = '';
            foreach ($_POST['id_relations'] as $i => $idc)
                $idcoms .= $idc.',';
            $idcoms = ",'".substr($idcoms, 0, -1)."'";
            $idcfield = ',id_community';
        }

        if ($relationField && $relationId) {
            $rf = ','.$relationField;
            $ri = ",'".$relationId."'";
        }

        $query = "INSERT INTO $relationTable(nome".$rf.$idcfield.") VALUES('$nome'".$ri.$idcoms.")";
        $rs = $connh->Execute($query);*/

        $idcoms = '';

        if (is_array($_POST['id_relations']) && count($_POST['id_relations'])) {
            foreach ($_POST['id_relations'] as $i => $idc)
                $idcoms .= $idc.',';
        }
        else
            $idcoms = '';

        $connh->Execute("INSERT INTO $relationTable(nome, `$relationField`) VALUES('".$nome."', '".substr($idcoms, 0, -1)."')");

    }
    unset($action);
    echo "<script language=\"Javascript\" type=\"text/javascript\">window.opener.location.replace(window.opener.location.href);</script>";
    if (!$rs) $msg = $err_insert_field;
}

if ($action == 'change')
{
    if (($tipo == 'int' && $lunghezza == '') || $tipo == 'text' || $tipo == 'date')
        $lung_str = '';
    else
        $lung_str = "($lunghezza)";
    $nome = trim($nome);
    $nome = str_replace(' ', '_', $nome);
    $query = "ALTER TABLE $table CHANGE $oldname $nome $tipo $lung_str";
    $rs = $connh->Execute($query) or die("ERRORE in action $action:$query<br />".$connh->ErrorMsg());

    // eseguo l'operazione anche per le corrispettive tabelle di lingua
    if (count($langs[$table]))
    foreach ($langs[$table] as $langtable => $langlabel) {
        $query = "ALTER TABLE $langtable CHANGE $oldname $nome $tipo $lung_str";
        $rs = $connh->Execute($query);
    }

    if ($relationTable) {
        $idcoms = '';

        if (is_array($_POST['id_relations']) && count($_POST['id_relations'])) {
            foreach ($_POST['id_relations'] as $i => $idc)
                $idcoms .= $idc.',';
        }
        else
            $idcoms = '';

        $connh->Execute("UPDATE $relationTable SET $relationField='".substr($idcoms, 0, -1)."' WHERE nome='".$nome."'");
    }

    unset($action);
    echo "<script language=\"Javascript\" type=\"text/javascript\">window.opener.location.replace(window.opener.location.href);</script>";
    if (!$rs) $msg = $err_insert_field;
}

elseif ($action == 'delfield')
{
    if (!is_array($_POST['fieldsdel']))
        $_POST['fieldsdel'] = unserialize(stripslashes($_POST['fieldsdel']));
    foreach ($_POST['fieldsdel'] as $key=>$val) {
        if ($val != '')
        {
            $query = "ALTER TABLE $table DROP $val";
            $rs = $connh->Execute($query);

            // eseguo l'operazione anche per le corrispettive tabelle di lingua
            if (count($langs[$table]))
            foreach ($langs[$table] as $langtable => $langlabel) {
                $query = "ALTER TABLE $langtable DROP $val";
                $rs = $connh->Execute($query);
            }

            if ($relationTable != '') {
                $where = '';
                if ($relationField && $relationId)
                    $where = "and `".$relationField."`='".$relationId."'";
                $query = "DELETE FROM $relationTable WHERE nome='$val' $where";
                $rs = $connh->Execute($query);
            }
            echo "<script language=\"Javascript\" type=\"text/javascript\">window.opener.location.replace(window.opener.location.href);</script>";
            if (!$rs) $msg = $msg.$err_delete_field.' '.$val;
        }
    }
    unset($action);
}

elseif ($action == 'del_field') // set attrib
{
    if ($relationTable != '')
    {
        $query = "SELECT * FROM $table";
        $rsT = $connh->Execute($query);

        for ($i=0; $i<$rsRel->FieldCount(); $i++)
        {
            $field = $rsRel->FetchField($i);
            if ($field->name != 'id' and $field->name != 'nome' and $field->name != 'id_community')
            {
                for ($c = 0; $c < $rsT->FieldCount(); $c++)
                {
                    $fieldT = $rsT->FetchField($c);
                    if ($fieldT->name != 'id' and $fieldT->name != 'username' and $fieldT->name != 'password' and $fieldT->name != 'email' and $fieldT->name != 'id_community' and $fieldT->name != 'id_catalogo')
                    {
                        $attrib_array = $_POST[$field->name."_attrib"];
                        if (is_array($attrib_array) && in_array($fieldT->name, $attrib_array))
                            $query = "UPDATE $relationTable SET ".$field->name."='true' WHERE nome='$fieldT->name'";
                        else
                            $query = "UPDATE $relationTable SET ".$field->name."='false' WHERE nome='".$fieldT->name."'";
                        $connh->Execute($query) or die("ERRORE $query<br />".$connh->ErrorMsg());
                    }
                }
            }
        }
        $where = '';
        if ($relationField && $relationId)
            $where = "WHERE `".$relationField."`='".$relationId."'";
        $query = "SELECT * FROM $relationTable $where";
        $relArray = $connh->getAll($query) or die("ERR: $query<br />".$connh->ErrorMsg());
    }
}

include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
?>

<script language="Javascript" type="text/javascript">
function checkField()
{
    if (document.form.tipo.value == 'varchar')
    {
        document.form.lunghezza.value = '255';
    }
}

function setModForm(field, type, maxl)
{
    var modform;
    modform = document.modform;
    modform.campo.value = field;
    /*var index;
    if (type == 'X') index = 2;
    if (type == 'C') index = 1;
    if (type == 'D') index = 4;
    if (type == 'I') index = 3;
    alert (modform.tipo);*/
    modform.tipo.value = type;
    modform.max_length.value = maxl;
    modform.submit();
}

</script>
<?
include PRISCILLA_LOCAL_PATH."adm/include/title.txt";
print "<link rel=\"stylesheet\" type=\"text/css\" href=\"".PRISCILLA_SERVER_PATH."adm/skin/$skin/default.css\">";
print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"".PRISCILLA_SERVER_PATH."adm/skin/ie6.css\" />
		<![endif]-->";
print "</head>";
include PRISCILLA_LOCAL_PATH."adm/skin/$skin/body.inc";
include PRISCILLA_LOCAL_PATH."adm/include/head_adm.inc.php";
?>
<table width="95%" class="table_border" align="center" cellpadding="2" cellspacing="1" border="0">
<tr><form name="form" id="form" method="post">
    <input type="hidden" name="action" value="<? if ($action == 'modifica') echo 'change'; else echo 'add';?>" />
    <? if ($action == 'modifica') echo "<input type=\"hidden\" name=\"oldname\" value=\"$campo\" />"; ?>
    <input type="hidden" name="table" value="<? echo $table; ?>" />
    <input type="hidden" name="relationtable" value="<? echo $relationTable; ?>" />
    <input type="hidden" name="<? echo $relationField; ?>" value="<? echo $relationId; ?>" />
    <th colspan="3" class="table_tit"><? echo adm_field_add; ?></th>
</tr><tr>
    <td colspan="3" width="100%" class="insert_voice"><? echo adm_field_desc; ?></td>
</tr><tr>
    <td width="50%" class="table_sez"><? echo adm_voice_name_fl; ?></td>
    <td width="25%" class="table_sez"><? echo adm_field_type; ?></td>
    <td width="25%" class="table_sez"><? echo adm_field_length; ?></td>
</tr><tr>
    <td class="insert_voice_dark" align="center"><input type="text" name="nome" style="width:100%" value="<? if ($action == 'modifica') echo $campo;?>" class="insert_area"></td>
    <td class="insert_voice_dark" align="center"><select name="tipo" size="1" style="width:100%" class="insert_area" onchange="checkField()">
    <?
    if ($action == 'modifica')
    {
        if ($tipo == 'X') $tipo = 'text';
        elseif ($tipo == 'C') $tipo = 'varchar';
        elseif ($tipo == 'I') $tipo = 'int';
        elseif ($tipo == 'D') $tipo = 'date';
        echo "<option value=\"$tipo\">$F_TYPES[$tipo]</option>";
    }
    ?>
    <option value=""></option>
    <option value="varchar"><? echo adm_field_text; ?></option>
    <option value="text"><? echo adm_field_longtext; ?></option>
    <option value="int"><? echo adm_field_number; ?></option>
    <option value="date"><? echo adm_field_date; ?></option>
    </select></td>
    <td class="insert_voice_dark" align="center"><input type="text" name="lunghezza" value="<? if ($action == 'modifica') echo $max_length;?>" style="width:100%" class="insert_area" /></td>
</tr><?
if ($relationTable == 'community_userFields') {
require_once PRISCILLA_LOCAL_PATH."modules/community/lang/$lang/community.diz";
?><tr>
    <td width="25%" class="table_sez"><? echo adm_community_abbina; ?></td>
    <td align="center" class="button_out" colspan="2">
    <select name="id_relations[]" id="id_relations" multiple="multiple" style="width:100%" size="3" class="insert_area">
    <?
    if ($action == 'modifica') {
        $rsr = $connh->Execute("SELECT id_community FROM community_userFields WHERE nome='".$campo."'");
        $comms = explode(',', $rsr->fields['id_community']);
    }
    $rsc = $connh->Execute("SELECT * FROM community WHERE proprietario='".$_COOKIE['login']."'");
    while (!$rsc->EOF) {
        $selected = '';
        if (in_array($rsc->fields['id'], $comms))
            $selected = 'selected="selected"';
        echo "<option value=\"".$rsc->fields['id']."\" $selected>[".$rsc->fields['id'].'] '.$rsc->fields['nome']."</option>";
        $rsc->MoveNext();
    }
    ?>
    </select></td>
</tr><?
}
elseif ($relationTable == 'catalogo_fields') { 
require_once PRISCILLA_LOCAL_PATH."modules/catalogo/lang/$lang/catalogo.diz";
?><tr>
    <td width="25%" class="table_sez"><? echo catalog_adm_abbina; ?></td>
    <td align="center" class="button_out" colspan="2">
    <select name="id_relations[]" id="id_relations" multiple="multiple" style="width:100%" size="3" class="insert_area">
    <?
    if ($action == 'modifica') {
        $rsr = $connh->Execute("SELECT id_catalogo FROM $relationTable WHERE nome='".$campo."'");
        $cats = explode(',', $rsr->fields['id_catalogo']);
    }

    $rsc = $connh->Execute("SELECT * FROM catalogo");
    while (!$rsc->EOF) {
        $selected = '';
        if (in_array($rsc->fields['id'], $cats))
            $selected = 'selected="selected"';
        echo "<option value=\"".$rsc->fields['id']."\" $selected>[".$rsc->fields['id'].'] '.$rsc->fields['nome']."</option>";
        $rsc->MoveNext();
    }
    ?>
    </select></td>
</tr>
<? } ?><tr>
    <td align="center" class="button_out" colspan="3"><input class="button_in awesome" type="Submit" value="<?php echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_but_exec."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>"></td>
</tr></form><?
if ($msg != '') echo <<<END
<tr>
    <td align="center" class="button_out" colspan="3">$msg</td>
</tr>
END;
?>
<?
$msg = '';

if ($action == 'del_field' && count($_POST['fieldsdel']) > 0)
{
?>
<tr><form name="form2" id="form2" method="post">
<input type="hidden" name="action" value="delfield" />
<input type="hidden" name="table" value="<? echo $table; ?>">
<input type="hidden" name="fieldsdel" value='<? echo serialize($_POST['fieldsdel']); ?>'>
<input type="hidden" name="<? echo $relationField; ?>" value="<? echo $relationId; ?>">
    <td colspan="3" class="insert_voice" align="center"><? echo adm_field_quest_del; ?></td>
</tr>
<?
foreach ($_POST['fieldsdel'] as $key => $val)
if ($val != '')
{?>
<tr>
    <td colspan="3" class="insert_voice" align="center"><? echo $val; ?></td>
</tr>
<?}?><tr>
    <td colspan="3" align="center" class="button_out" colspan="3"><input class="button_in" type="button" value="<?php echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_yes."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" onclick="document.form2.submit()">&nbsp;<input class="button_in" type="button" value="<?php echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_no."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" onclick="window.location.href='<? echo $_SERVER['PHP_SELF']; ?>?table=<? echo $table; ?>&relationTable=<? echo $relationTable; ?>'"></td>
</tr>
</form>
<?
}
?>
</table><br />

<table width="95%" class="table_border" align="center" cellpadding="2" cellspacing="1" border="0">
<tr><form method="post">
    <input type="hidden" name="action" value="del_field" />
    <input type="hidden" name="table" value="<? echo $table; ?>">
    <input type="hidden" name="relationTable" value="<? echo $relationTable; ?>">
    <th colspan="<? echo ($totRelationAttrib != 0) ? 5+$totRelationAttrib : 5; ?>" class="table_tit"><? echo adm_field_tit; ?></th>
</tr><tr>
    <td width="50%" class="table_sez"><? echo adm_voice_name_fl; ?></td>
    <td width="25%" class="table_sez"><? echo adm_field_type; ?></td>
    <td width="15%" class="table_sez"><? echo adm_field_length; ?></td>
    <? if ($totRelationAttrib != 0)
    {
        foreach ($relationTableAttrib as $key=>$val)
        {
    ?>
    <td align="center" class="table_sez"><? echo strtoupper($val); ?></td>
    <?  }
    }
    ?>
    <td colspan="2" align="center" class="table_sez"><? echo adm_voice_act; ?></td>
</tr>
<?
$query = "SELECT * FROM $table";
$rs = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());
for ($i=0; $i<$rs->FieldCount(); $i++)
{
    $field = $rs->FetchField($i);

    if ($relationTable && $relationField && $relationId) {
        $rsrc = $connh->Execute("SELECT COUNT(id) AS c FROM ".$relationTable." WHERE nome='".$field->name."' and `".$relationField."`='".$relationId."'");
        if ($rsrc->fields['c'] <= 0)
            continue;
    }

    if ($field->name != 'da' and $field->name != 'a' and $field->name != 'id_image' and $field->name != 'id' and $field->name != 'gid' and $field->name != 'hits' and $field->name != 'id_catalogo' and $field->name != 'id_community' and $field->name != 'content_visible' and $field->name != $relationField and $field->name != 'username' and $field->name != 'password' and $field->name != 'email' && $field->name != 'activationcookie' && $field->name != 'isactivestatus' && $field->name != 'time_request' && $field->name != 'time_activation' && $field->name != 'time_remove')
    {
    $m_type = $rs->MetaType($field->type);
    if ($m_type == 'X') $tipo = 'testo lungo';
    elseif ($m_type == 'C') $tipo = 'testo';
    elseif ($m_type == 'I') $tipo = 'numero';
    elseif ($m_type == 'D') $tipo = 'data';
    echo <<<END
<tr>
    <td width="50%" class="insert_voice">$field->name</td>
    <td class="insert_voice">$tipo</td>
    <td align="center" class="insert_voice">$field->max_length</td>
END;
    if ($totRelationAttrib != 0)
    {
        $where = '';
        if ($relationField && $relationId)
            $where = "and `".$relationField."`='".$relationId."'";
        foreach ($relationTableAttrib as $key=>$val)
        {
            $query = "SELECT $val FROM $relationTable WHERE nome='".$field->name."' $where";
            $rstemp = $connh->Execute($query);
            echo "<td width=\"2%\" align=\"center\" class=\"insert_voice\"><input type=\"checkbox\" name=\"".$val."_attrib[]\" value=\"".$field->name."\"";
            if ($rstemp->fields($val) == 'true') echo ' checked';
            echo "></td>";
        }
    }

    echo "<td width=\"8%\" align=\"center\" class=\"insert_voice\"><a href=\"javascript:setModForm('".$field->name."', '$m_type', '".$field->max_length."')\">".adm_voice_edit."</a></td>
    <td width=\"2%\" align=\"center\" class=\"insert_voice\">";
    if (substr($table, 0, 8) == 'content_') {
        if ($field->name != 'titolo')
            echo "<input type=\"checkbox\" name=\"fieldsdel[]\" value=\"".$field->name."\">";
    }
    else
        echo "<input type=\"checkbox\" name=\"fieldsdel[]\" value=\"".$field->name."\">";

    echo "</td>
</tr>";
    }
}
?><tr>
    <td align="center" class="button_out" colspan="3">&nbsp;</td>
    <? if ($totRelationAttrib != 0) { ?>
    <td colspan="<? echo $totRelationAttrib; ?>" align="center" class="button_out"><input class="button_in" type="submit" value="set attribute" /></td>
    <? } ?>
    <td align="center" class="button_out">&nbsp;</td>
    <td align="center" class="button_out"><input class="button_in" type="submit" value="<?php echo adm_voice_del; ?>" /></td>
</tr></form>
<form name="modform" action="<? echo $_SERVER['PHP_SELF']; ?>">
<input type="hidden" name="action" value="modifica" />
<input type="hidden" name="table" value="<? echo $table; ?>">
<input type="hidden" name="campo" value="" />
<input type="hidden" name="tipo" value="" />
<input type="hidden" name="max_length" value="" />
<input type="hidden" name="relationTable" value="<? echo $relationTable; ?>">
<input type="hidden" name="<? echo $relationField; ?>" value="<? echo $relationId; ?>">
</form>
</table><br />
<?php
    include PRISCILLA_LOCAL_PATH."adm/include/about_adm.inc.php";
?>
</body></html>
