<?
//$Id: search_linear.inc.php,v 1.3 2009/04/03 13:07:57 antonio Exp $

/**
 ** tag: ricerca
 ** desc: stampa il form per il motore di ricerca specificato
 ** opt: id id del motore di ricerca
 ** opt: targetid id della pagina in cui si trova il corrispondente tag di report se non e' fornito si assume che il tag di report si trovi in quella stessa pagina
 ** opt: classform style css per formattare il campo di input, default search_form
 ** opt: classbutton style css per formattare il bottone, default search_button
 ** opt: classselect style css per formattare le tendine, default search_select
 ** opt: defaultvalue valore di default per il campo input della ricerca
**/

function ricerca ($connh, $row, $PRISCILLA_SESSION, $options)
{
    global $lang;

    if ($options[targetid] == '')
        $idp = $row[id];
    else
        $idp = $options[targetid];
    $ids = $options[id];

    $classform = $options[classform] != '' ? $options[classform] : 'search_form';
    $classbutton = $options[classbutton] != '' ? $options[classbutton] : 'search_button';
    $classselect = $options[classselect] != '' ? $options[classselect] : 'search_select';

    if ($PRISCILLA_SESSION->exists("priscilla_search_params")) {

        $priscilla_search_params =  $PRISCILLA_SESSION->getvalue('priscilla_search_params');

        $check_inner = $priscilla_search_params['innerwords'] ? "checked" : "";
        $check_case = $priscilla_search_params['casesensitive'] ? "checked" : "";
        $old_keywords = trim($priscilla_search_params['keywords']);
        $select_metaname = $priscilla_search_params['metaname'];
        $select_ramo =  $priscilla_search_params['ramo'];
    } else {

        $check_inner = "";
        $check_case = "";
        $old_keywords = "";
        $select_metaname = "";
        $select_ramo = "";
    }

    $templang = $lang;
    // una lingua ci deve pur essere
    if (trim($templang) == '')
        $templang = 'ita';
    require "tools/lang/$templang/dialog.diz";

    if ($old_keywords == '')
    {
        $old_keywords = ($options['defaultvalue']) ? $options['defaultvalue'] : dialog_meta_keys;
        $jsclick = "onclick=\"javascript:this.value=''\"";
    }

    $query = "SELECT * FROM search_dat WHERE id='$ids'";
    $rowrsS = $connh->Execute($query);

    if ($rowrsS->RecordCount() > 0)
    {
        $subst = "<form id=\"search_$ids\" action=\"lib/finder.php\" method=\"post\"><fieldset>";
        $subst .= "<input type=\"hidden\" name=\"id\" id=\"id\" value=\"$ids\" />";
        $subst .= "<input type=\"hidden\" name=\"idp\" id=\"idp\" value=\"$idp\" />";

        $srow = $rowrsS->fields;
        if ($srow[codice] != '') {

            $codice = $srow[codice];
            $form = "<input type=\"text\" name=\"keywords\" id=\"keywords\" value=\"$old_keywords\" class=\"".$classform."\" $jsclick />\n";
            $button = "<input type=\"submit\" class=\"".$classbutton."\" id=\"butt_search\" value=\"".dialog_but_search_value."\" />\n";

            $casesensitive =
                "<input type=\"checkbox\" name=\"opt_casesensitive\" id=\"opt_casesensitive\" $check_case class=\"search_form\" value=\"ok\" />\n";

            $innerwords =
                "<input type=\"checkbox\" name=\"opt_innerwords\" id=\"opt_innerwords\" $check_inner class=\"search_form\" value=\"ok\" />\n";

            $codice = str_replace("{form}",$form, $codice);
            $codice = str_replace("{button}", $button, $codice);
            $codice = str_replace("{casesensitive}", $casesensitive, $codice);
            $codice = str_replace("{innerwords}", $innerwords, $codice);
    
    
            $ramo = "<select name=\"ramo\" id=\"ramo\" class=\"".$classselect."\">\n";
            $ramo .= "<option value=\"1\">".dialog_finder_allbranch."</option>";
            $query = "SELECT sezione FROM node WHERE id='$row[ramo]'";
            $rowrs1 = $connh->Execute($query);
            $srow2 = $rowrs1->fields;
    
            if ($select_ramo != "")
                $select_this_ramo = $srow[ramo] == $select_ramo ? "selected" : "";
    
            $ramo .= "<option $select_this_ramo value=\"$srow[ramo]\">$srow2[sezione]</option>";
            $query = "SELECT * FROM node WHERE id_parent=1 and pubblicazione='pubblica'";
            $rowrs1 = $connh->Execute($query);
            while (!$rowrs1->EOF)
            {
                $row1 = $rowrs1->fields;
                if ($row1[sezione] != $srow[ramo]) {
                    if ($select_ramo != "")
                        $select_this_ramo = $row1[id] == $select_ramo ? "selected" : "";
                    $ramo .= "<option $select_this_ramo  value=\"$row1[id]\">$row1[sezione]</option>\n";
                }
                $rowrs1->MoveNext();
            }
            $ramo .= "\n</select>";
    
            if (strstr($codice, "{ramo}"))
            {
                if ($srow[ramo] != '')
                    $codice = str_replace("{ramo}", $ramo, $codice);
            }
            else $codice .= "<input type=\"hidden\" name=\"ramo\" id=\"ramo\" value=\"$srow[ramo]\" />";
    
            $select_no = $select_metaname == 'no' ? "selected" : "";
            $select_si = $select_metaname == 'si' ? "selected" : "";
    
            $metaname = "<select name=\"metaname\" class=\"".$classselect."\">
            <option $select_no value=\"no\">".dialog_finder_contents."</option>
            <option $select_si value=\"si\">".dialog_finder_keywords."</option>
            </select>";
            $codice = str_replace("{keywords}", $metaname, $codice);
        }
    }

    $subst .= $codice;
    $subst .= "</fieldset></form>";


return $subst;
}



?>
